#include <bits/stdc++.h>
using namespace std;

const int MOD = 1000000007;

int main() {
    int R, C;
    cin >> R >> C;
    string W;
    cin >> W;
    vector<string> board(R);
    for (int r=0; r<R; ++r) cin >> board[r];

    vector< vector<int> > ways(R, vector<int>(C,0));
    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (board[r][c] == W[0]) ways[r][c] = 1;

    for (int n=1; n<int(W.size()); ++n) {
        vector< vector<int> > newways(R, vector<int>(C,0));
        for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (board[r][c] == W[n]) {
            for (int r2=0; r2<R; ++r2) for (int c2=0; c2<C; ++c2) {
                int dr = abs(r-r2), dc = abs(c-c2);
                if (dr != 0 && dc != 0 && dr != dc) {
                    newways[r][c] += ways[r2][c2];
                    if (newways[r][c] >= MOD) newways[r][c] -= MOD;
                }
            }
        }
        ways = newways;
    }

    long long answer = 0;
    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) answer += ways[r][c];
    answer %= MOD;
    cout << answer << endl;
}
